<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;

class FilioperLancamentoNotafiscal extends \Teknisa\DF\Controllers\TeknisaCrud
{
    

    public function __construct($crudService, $parameterBag, $environment, $entityManager) {
        parent::__construct($crudService, $parameterBag);
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
    }
    

    protected $dataSourceName = 'filioper_lancamento_notafiscal';
    protected $parameterBagColumns = array(
        'CDOPERADOR'
    );
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $utilizaControleAcessoPorFilial = $this->utilizaControlePorFilial();

        if($utilizaControleAcessoPorFilial["IDUTLPERFILFILIAL"] == 'S') {
            $this->parameterBagColumns[] = 'P_IDSTATUSBLOQ';
            
            $blockFilial = $utilizaControleAcessoPorFilial["IDBLOCKFILIAL"];
            
            $request->getFilterCriteria()->addCondition("P_IDSTATUSBLOQ", "=", $blockFilial);
            $this->dataSourceName = 'perfacessfili_lancamento_notafiscal';
            parent::find($request, $response);
        }
        else {
            $this->dataSourceName = 'filioper_lancamento_notafiscal';
            parent::find($request, $response);
        }
    }
    
    public function utilizaControlePorFilial() {
        try {
            $sql = "SELECT
                        PA.IDBLOCKFILIAL, 
                        PG.IDUTLPERFILFILIAL
                    FROM
                        PERFILACESSO   PA,
                        PARAMGERAL     PG,
                        OPERADOR       O
                    WHERE CDPARGERAL = '0001'
                    AND PA.NRPERFILACESSO = O.CDPERFILSELECIONADO
                    AND O.CDOPERADOR = :P_CDOPERADOR";
                    
            $params = array(
                "P_CDOPERADOR" => $this->environment->getCdOperador()
            );
            
            $std = $this->entityManager->getConnection()->prepare($sql);
            $std->execute($params);    
            return $std->fetch();
        }
        catch(\Exception $e) {
            return array("IDBLOCKFILIAL" => 'N', "IDUTLPERFILFILIAL" => 'N');
        }
    }
}