<?php

namespace Teknisa\DF\Modules\Relatorios\Services;

use Doctrine\ORM\EntityManager;

class ManifestacaoDestinatarioRelatorioService {
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getRelatorio($IDENTRSAIDNF, $CDTIPOOPER, $CDEMPRESA, $IDSTATUSNFENF, $IDENTRSAIDOP, $IDORIGDESTNF, $NRINSJURIEST, $CDINSCESTA, $IDSTATUSNFE, $IDSTATUSMANIF, $NRACESSONFE, $SINCRONIZACAO, $P_DTEMISSAOINI, $P_DTEMISSAOFIN)
    {
        $sql = <<<SQL
           SELECT NRORG,
                  CDFILIALORIG,
                  CDEMPRESA,
                  NRINSJURNFORIG ,
                  NMRAZSOCEMIT AS DSINSJURNF,
                  NRNOTAFISC,
                  DTENTRSAID,
                  TRUNC(DTEMISSAO) as DTEMISSAO,
                  CDSERIE,
                  DSSERIE,
                  VRNOTAFISC,
                  IDSTATUSNFE,
                  IDSTATUSMANIF,
                  IDTIPOINCL,
                  IDTIPOEVENTO,
                  IDAMBIENTEMANIF,
                  DTHREVENTO,
                  NRSEQEVENTO,
                  DSCORRECAONFE,
                  DSOBSSTATUSMANIF,
                  CDFILIAL,
                  NRLANCTONF,
                  NRINSJURNF,
                  IDENTRSAIDNF,
                  IDENTRSAIDOP,
                  NRACESSONFE,
                  IDNOTA,
                  IDARQXMLNFE,
                  NRACESSOINTG,
                  NRLANCTONFDEST,
                  DTRECBTO,
                  FILIALCNPJ,
                  NMFILIALCNPJ,
                  NRINSJURIEST,
                  :SINCRONIZACAO AS SINCRONIZACAO,
                  :CDINSCESTA    AS CDINSCESTA,
                  :IDORIGDESTNF  AS IDORIGDESTNF,
                  :IDSTATUSNFENF AS IDSTATUSNFENF,
                  :CDTIPOOPER    AS CDTIPOOPER
                FROM
                  (SELECT D.NRORG,
                    DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIRECE, N.CDFILIEMIT) AS CDFILIALORIG,
                    N.CDEMPRESA,
                    D.NRINSJUREMIT AS NRINSJURNFORIG,
                    D.NMRAZSOCEMIT,
                    D.NRNOTAFISC,
                    N.DTENTRSAID,
                    D.DTEMISSAO,
                    N.CDSERIE,
                    N.DSSERIE,
                    D.VRNOTAFISC,
                    D.IDSTATUSNFE,
                    D.IDSTATUSMANIF,
                    DECODE(N.IDNFGERADAVIAXML , '', ' - ', DECODE(N.IDNFGERADAVIAXML, 'N', 'M', 'X')) IDTIPOINCL,
                    D.IDTIPOEVENTO,
                    D.IDAMBIENTEMANIF,
                    D.DTHREVENTO,
                    D.NRSEQEVENTO,
                    D.DSCORRECAONFE,
                    D.DSOBSSTATUSMANIF,
                    N.CDFILIAL,
                    N.NRLANCTONF,
                    N.NRINSJURNF,
                    D.IDENTRSAIDNF,
                    N.IDENTRSAIDOP,
                    D.NRACESSONFE,
                    DECODE(D.NRLANCTONF, '', DECODE(D.NRACESSOINTG, '', '1', '4'), DECODE(D.NRACESSOINTG, '', '2', '3')) IDNOTA,
                    NVL(I.IDARQXMLNFE, 'N') IDARQXMLNFE,
                    D.NRACESSOINTG,
                    D.NRLANCTONF AS NRLANCTONFDEST,
                    D.DTRECBTO,
                    V.FILIALCNPJ,
                    V.NMFILIALCNPJ,
                    V.NRINSJURIEST
                  FROM NOTADESTINADA D,
                    (SELECT L.CDFILIAL,
                      L.NRLANCTONF,
                      L.IDENTRSAIDOP,
                      L.CDFILIRECE,
                      L.CDFILIEMIT,
                      L.CDEMPRESA,
                      L.DTENTRSAID,
                      NVL(L.CDSERIE,L.CDSERIEENTR) AS CDSERIE,
                      S.DSSERIEENTR                AS DSSERIE,
                      L.VRNOTAFISC,
                      L.IDNFGERADAVIAXML,
                      L.NRINSJURNF
                    FROM NOTAFISCAL L
                    LEFT JOIN SERIEENTR S
                    ON L.CDSERIEENTR = S.CDSERIEENTR
                    JOIN INSCRESTAD I
                    ON (L.CDEMPRESA   = I.CDEMPRESA)
                    AND (L.CDINSCESTA = I.CDINSCESTA),
                      (SELECT IDENTRSAIDOP ,
                        CDTIPOOPER
                      FROM TIPOOPERAC
                      WHERE ((INSTR(:IDENTRSAIDOP, IDENTRSAIDOP) > 0)
                      OR :IDENTRSAIDOP                           = 'TD')
                      AND ((INSTR(:CDTIPOOPER, CDTIPOOPER)       > 0)
                      OR :CDTIPOOPER                             = 'TD')
                      )T
                    WHERE ((INSTR(:CDEMPRESA, L.CDEMPRESA)     > 0)
                    OR (:CDEMPRESA                             = 'TD'))
                    AND ((INSTR(:CDINSCESTA, L.CDINSCESTA)     > 0)
                    OR (:CDINSCESTA                            = 'TD'))
                    AND ((INSTR(:NRINSJURIEST, I.NRINSJURIEST) > 0)
                    OR (:NRINSJURIEST                          = 'TD'))
                    AND L.DTEMISSAO BETWEEN :P_DTEMISSAOINI AND :P_DTEMISSAOFIN
                    AND L.IDENTRSAIDOP                         = T.IDENTRSAIDOP
                    AND L.CDTIPOOPER                           = T.CDTIPOOPER
                    AND ((INSTR(:IDSTATUSNFENF, L.IDSTATUSNFE) > 0)
                    OR :IDSTATUSNFENF                          = 'TD')
                    AND ((L.NRACESSONFE                        = :NRACESSONFE)
                    OR (:NRACESSONFE                           = 'TD'))
                    AND L.IDSISTEMA NOT                       IN ('PAG', 'FIS')
                    ) N,
                    INTG_NOTAFISCAL I,
                    (SELECT F.CDFILIAL AS FILIALCNPJ,
                      F.NMFILIAL       AS NMFILIALCNPJ,
                      I.NRINSJURIEST,
                      F.CDINSCESTA
                    FROM FILIAL F,
                      INSCRESTAD I
                    WHERE F.CDINSCESTA                     = I.CDINSCESTA
                    AND F.CDEMPRESA                        = I.CDEMPRESA
                    AND ((INSTR(:CDINSCESTA, F.CDINSCESTA) > 0)
                    OR (:CDINSCESTA                        = 'TD'))
                    ) V
                  WHERE D.CDFILIAL                           = N.CDFILIAL(+)
                  AND D.NRLANCTONF                           = N.NRLANCTONF(+)
                  AND D.NRACESSONFE                          = I.NRACESSONFE(+)
                  AND D.NRINSJURIEST                         = V.NRINSJURIEST
                  AND ((INSTR(:NRINSJURIEST, D.NRINSJURIEST) > 0)
                  OR (:NRINSJURIEST                          = 'TD'))
                  AND ((INSTR(:CDINSCESTA, D.CDINSCESTA)     > 0)
                  OR (:CDINSCESTA                            = 'TD'))
                  AND D.DTEMISSAO BETWEEN :P_DTEMISSAOINI AND :P_DTEMISSAOFIN
                  AND ((INSTR(:IDENTRSAIDNF, D.IDENTRSAIDNF)   > 0)
                  OR :IDENTRSAIDNF                             = 'TD')
                  AND ((INSTR(:IDSTATUSNFE, D.IDSTATUSNFE)     > 0)
                  OR :IDSTATUSNFE                              = 'TD')
                  AND ((INSTR(:IDSTATUSMANIF, D.IDSTATUSMANIF) > 0)
                  OR :IDSTATUSMANIF                            = 'TD')
                  AND ((D.NRACESSONFE                          = :NRACESSONFE)
                  OR (:NRACESSONFE                             = 'TD'))
                  AND (((INSTR(:SINCRONIZACAO, '1')            > 0)
                  AND D.NRLANCTONF                            IS NULL
                  AND D.NRACESSOINTG                          IS NULL)
                  OR ((INSTR(:SINCRONIZACAO, '2')              > 0)
                  AND D.NRLANCTONF                            IS NOT NULL)
                  OR ((INSTR(:SINCRONIZACAO, '3')              > 0)
                  AND D.NRLANCTONF                            IS NULL
                  AND D.NRACESSOINTG                          IS NOT NULL)
                  OR (:SINCRONIZACAO                           = 'TD'))
                  UNION ALL
                  SELECT NF.NRORG,
                    DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIRECE, NF.CDFILIEMIT) AS CDFILIALORIG,
                    NF.CDEMPRESA,
                    NF.NRINSJURNF AS NRINSJURNFORIG,
                    DECODE(NF.IDORIGDESTNF, 'L', L.NMFILIAL, DECODE(NF.IDORIGDESTNF, 'C', C.NMRAZSOCCLIE, F.NMRAZSOCFORN)) NMRAZSOCEMIT,
                    NF.NRNOTAFISC,
                    NF.DTENTRSAID,
                    NF.DTEMISSAO,
                    DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE) AS CDSERIE,
                    S.DSSERIEENTR                                            AS DSSERIE,
                    NF.VRNOTAFISC,
                    '0' IDSTATUSNFE ,
                    '0' IDSTATUSMANIF,
                    DECODE(NF.IDNFGERADAVIAXML, 'N', 'M', 'X') AS IDTIPOINCL,
                    NULL IDTIPOEVENTO,
                    NULL IDAMBIENTEMANIF,
                    NULL DTHREVENTO,
                    NULL NRSEQEVENTO,
                    NULL DSCORRECAONFE,
                    NULL DSOBSSTATUSMANIF,
                    NF.CDFILIAL,
                    NF.NRLANCTONF,
                    NF.NRINSJURNF,
                    NULL IDENTRSAIDNF,
                    NF.IDENTRSAIDOP,
                    NF.NRACESSONFE,
                    DECODE(NF.IDNFGERADAVIAXML, 'N', '5', '6') IDNOTA,
                    NVL(IT.IDARQXMLNFE, 'N') IDARQXMLNFE,
                    '' NRACESSOINTG,
                    NULL AS NRLANCTONFDEST,
                    SYSDATE DTRECBTO,
                    V.FILIALCNPJ,
                    V.NMFILIALCNPJ,
                    V.NRINSJURIEST
                  FROM NOTAFISCAL NF,
                    INTG_NOTAFISCAL IT,
                    SERIEENTR S,
                    INSCRESTAD I,
                    (SELECT IDENTRSAIDOP,
                      CDTIPOOPER
                    FROM TIPOOPERAC
                    WHERE (INSTR(:IDENTRSAIDOP, IDENTRSAIDOP) > 0)
                    AND ((INSTR(:CDTIPOOPER, CDTIPOOPER)      > 0)
                    OR :CDTIPOOPER                            = 'TD')
                    ) T,
                    (SELECT CDMODDOCFISC FROM MODDOCFISC WHERE IDMODDOCNFE = 'S'
                    ) M,
                    (SELECT CDCLIENTE, NRINSJURCLIE, NMRAZSOCCLIE FROM CLIENTE
                    ) C,
                    (SELECT CDFORNECED, NRINSJURFORN, NMRAZSOCFORN FROM FORNECEDOR
                    ) F,
                    (SELECT CDFILIAL, NRINSJURFILI, NMFILIAL FROM FILIAL
                    ) L,
                    (SELECT F.CDFILIAL AS FILIALCNPJ,
                      F.NMFILIAL       AS NMFILIALCNPJ,
                      I.NRINSJURIEST,
                      F.CDINSCESTA
                    FROM FILIAL F,
                      INSCRESTAD I
                    WHERE F.CDINSCESTA                     = I.CDINSCESTA
                    AND F.CDEMPRESA                        = I.CDEMPRESA
                    AND ((INSTR(:CDINSCESTA, F.CDINSCESTA) > 0)
                    OR (:CDINSCESTA                        = 'TD'))
                    ) V
                  WHERE NF.CDEMPRESA                                            = I.CDEMPRESA
                  AND NF.CDINSCESTA                                             = I.CDINSCESTA
                  AND V.CDINSCESTA                                              = I.CDINSCESTA
                  AND V.NRINSJURIEST                                            = I.NRINSJURIEST
                  AND ((INSTR(:CDEMPRESA, NF.CDEMPRESA)                         > 0)
                  OR (:CDEMPRESA                                                = 'TD'))
                  AND ((INSTR(:CDINSCESTA, NF.CDINSCESTA)                       > 0)
                  OR (:CDINSCESTA                                               = 'TD'))
                  AND ((INSTR(:NRINSJURIEST, I.NRINSJURIEST)                    > 0)
                  OR (:NRINSJURIEST                                             = 'TD'))
                  AND (NF.IDENTRSAIDOP                                          = T.IDENTRSAIDOP)
                  AND (NF.CDTIPOOPER                                            = T.CDTIPOOPER)
                  AND NF.CDSERIEENTR                                            = S.CDSERIEENTR(+)
                  AND NF.CDCLIENTE                                              = C.CDCLIENTE(+)
                  AND NF.CDFORNECED                                             = F.CDFORNECED(+)
                  AND DECODE(NF.IDENTRSAIDOP,'E', NF.CDFILIEMIT, NF.CDFILIRECE) = L.CDFILIAL(+)
                  AND (NF.DTEMISSAO BETWEEN :P_DTEMISSAOINI AND :P_DTEMISSAOFIN)
                  AND ((INSTR(:IDSTATUSNFENF, NF.IDSTATUSNFE) > 0)
                  OR :IDSTATUSNFENF                           = 'TD')
                  AND (:IDSTATUSMANIF                         = '0'
                  OR :IDSTATUSMANIF                           = 'TD')
                  AND ((NF.NRACESSONFE                        = :NRACESSONFE)
                  OR (:NRACESSONFE                            = 'TD'))
                  AND (:SINCRONIZACAO                         = '0'
                  OR :SINCRONIZACAO                           = 'TD')
                  AND NF.IDSISTEMA NOT                       IN ('PAG', 'FIS')
                  AND NF.CDMODDOCFISC                         = M.CDMODDOCFISC
                  AND NF.NRACESSONFE                          = IT.NRACESSONFE(+)
                  AND NOT EXISTS
                    (SELECT NRACESSONFE
                    FROM NOTADESTINADA D
                    WHERE D.CDFILIAL = NF.CDFILIAL
                    AND D.NRLANCTONF = NF.NRLANCTONF
                    )
                  )
SQL;
        $params = array(
            "IDENTRSAIDNF" => $IDENTRSAIDNF,
            "CDTIPOOPER" => $CDTIPOOPER,
            "CDEMPRESA" => $CDEMPRESA,
            "IDSTATUSNFENF" => $IDSTATUSNFENF,
            "IDENTRSAIDOP" => $IDENTRSAIDOP,
            "IDORIGDESTNF" => $IDORIGDESTNF,
            "NRINSJURIEST" => $NRINSJURIEST,
            "CDINSCESTA" => $CDINSCESTA,
            "IDSTATUSNFE" => $IDSTATUSNFE,
            "IDSTATUSMANIF" => $IDSTATUSMANIF,
            "NRACESSONFE" => $NRACESSONFE,
            "SINCRONIZACAO" => $SINCRONIZACAO,
            "P_DTEMISSAOINI" => $P_DTEMISSAOINI,
            "P_DTEMISSAOFIN" => $P_DTEMISSAOFIN
        );
        
        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

}
